function InitSecurity() {
	// This dumps all the friends groups into a listbox.
	var friends_groups = document.getElementById("friendsgroups");
	friends_groups.removeChild(friends_groups.firstChild);
    for (i=0; i < opener.opener.result.groups.length; i++) {
		if (opener.opener.result.groups[i]) {
			friends_groups.appendItem(opener.opener.result.groups[i],i+1);
		}
	}
	document.getElementById("securityradio").selectedIndex = Backwards(opener.document.getElementById("security").selectedIndex);
	GroupsSelected(document.getElementById("custom").selected);
	if (document.getElementById("custom").selected) { GroupsUnmask(opener.groups); }
}

function Backwards(indexnum,up) {
	// This is a workaround for a really bizarre Firefox bug. It seems to count items in radiogroups backwards for some reason,
	// so that 0 is the last one and 3 is the first one, instead of the other way around...
	var num = indexnum;
	if (opener.getPrefDS().GetBoolPref("deepestSender.IsFirefox")) {
		num = Math.abs(num - 3);
	}
	return num;
}

function GroupsSelected(yes) {
	// This is just to enable/disable the stuff in the listbox, depending on what radio button is checked.
	// It'd be better if I could just go friendsgroups.disabled, but unfortunately it doesn't seem to work.
	var groupslist = document.getElementById("friendsgroups").childNodes;
	for (i = 0; i < groupslist.length; i++) {
		if (yes) {
			groupslist[i].setAttribute("disabled", "false");
		} else {
			groupslist[i].setAttribute("disabled", "true");
		}
			groupslist[i].setAttribute("type", "checkbox");
	}
}

function GroupsMask() {
	// Hooray. This bit sucks. The way the LJ protocol goes is that to set friends groups, you send a 32 bit binary number that is used as a mask,
	// with bit 0 turned off. Turn it on if you want to give all friends access. So if you wanted to give friends groups 1 and 3 access, you'd send
	// the binary number (converted to an integer, thats what all this is for) 1010. Going from the right to left. So you get a nice long string of 32
	// ones and zeros, then convert that into an unsigned integer. Easiest way I found was to make an array 32 bits long, filled with zeros, then run
	// through the groupslist, and every friends group that was checked, it sets the corresponding number in the array to 1.
	var friendsmaskarray = [];
	for (i = 0; i < 32; i++) {
		friendsmaskarray[i] = 0;
	}
	var groupslist = document.getElementById("friendsgroups").childNodes;
	for (i=0; i < groupslist.length; i++) {
		if (groupslist[i].checked == true) {
			var groupindex;
			// This is to reverse the number. The array goes from left to right, and binary (and all numbers) goes from right to left, so this just swaps
			// where the bits are.
			groupindex = Math.abs(groupslist[i].getAttribute("value") - 31);
			friendsmaskarray[groupindex] = 1;
			// It just keeps setting it to zero because I was having problems with it before. This is to ensure I don't screw up again and make friends-only
			// posts really a custom group with no people in it.
			friendsmaskarray[31] = 0;
		}
	}
	var friendsmask = parseInt(friendsmaskarray.join(""),2);
	return friendsmask;
}

function OkClicked() {
	var security = opener.document.getElementById("security");
	var thissecurity = Backwards(document.getElementById("securityradio").selectedIndex, true);

	opener.groups = 1;
	if (thissecurity == 3) {
		// If Custom is selected, get the friends mask.
		opener.groups = GroupsMask();
		if (opener.groups == 0) {
			thissecurity = 1;
			opener.groups = 1;
		}
	}
	security.selectedIndex = thissecurity;
	window.close();
}

function GroupsUnmask(mask) {
	// Unfortunately, people might change their mind after clicking OK and want to change their selection, so this is to check everything again. Basically
	// the same function as GroupsMask() except backwards.
	var friendsmask = mask;
	var friendsmaskarray = [];
	for (i = 0; i < 32; i++) {
		friendsmaskarray[i] = 0;
	}
	var groupslist = document.getElementById("friendsgroups").childNodes;
	
	for (i = friendsmaskarray.length -1; i >= 0; i--) {
		// Note that this creates a number thats basically a mirror image of what it was originally calculated to be. So I thought "stuff it" and count from left
		// to right instead.
		var powpos = Math.pow(2,i);
		if (friendsmask >= powpos) {
			friendsmaskarray[i] = 1;
			friendsmask = friendsmask - powpos;
		}
	}
	// If the number in the array is 1, then check the box that matches it.
	for (i = 1; i < friendsmaskarray.length; i++) {
		if (friendsmaskarray[i] == 1) {
			groupslist[i-1].setAttribute("checked","true");
		}
	}
}